package com.example.ydsdkdemo

import android.app.Activity
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.util.Log
import android.widget.Button
import android.widget.EditText
import android.widget.RelativeLayout
import com.example.ydsdkdemo.util.CommonDeviceInfo
import com.example.ydsdkdemo.util.SharedPreferencesUtils
import com.example.ydsdkdemo.BuildConfig
import com.open.ad.polyunion.bean.CAdInfo
import com.open.ad.polyunion.listener.AdViewListener
import com.open.ad.polyunion.view.AdConfig
import com.open.ad.polyunion.view.AdRequestConfig
import com.open.ad.polyunion.view.AdView
import com.example.ydsdkdemo.R

class BannerActivity : Activity() {

    var container: RelativeLayout? = null
    var showBanner: Button? = null
    var refreshBanner: android.widget.Button? = null
    var bannerView: AdView? = null
    var bannerEdit: EditText? = null
    private var isShowDownloadConfirmDialog = false

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_banner)
        isShowDownloadConfirmDialog =
            SharedPreferencesUtils.getParam(this, "isShowDownloadConfirmDialog", true) as Boolean
        showBanner = findViewById(R.id.showBannerAd)
        refreshBanner = findViewById(R.id.refreshBannerAd)
        container = findViewById(R.id.bannerContainer)
        bannerEdit =findViewById(R.id.banner_edit)

        showBanner!!.setOnClickListener { showNormalBanner() }
        refreshBanner!!.setOnClickListener {
//          if (bannerView != null) {
//             bannerView.refreshBannerNow();//调用后立即刷新横幅广告
//          }
            showNormalBanner()
            Handler(Looper.getMainLooper()).postDelayed({ finish() }, 200)
        }
    }

    // 普通banner
    private fun showNormalBanner() {
        val requestConfig: AdRequestConfig = AdRequestConfig.Builder()
            .AdType(AdConfig.AD_TYPE_BANNER)
            .slotId(BuildConfig.COMMOM_BANNER_SLOT_ID)//广告位id
            .sceneId(bannerEdit?.text.toString()) //广告场景id
            .widthDp(CommonDeviceInfo.getScreenSizeInDp(applicationContext)[0])
            .heightDp(0)//0为自适应
            .bannerInterval(0)//轮播时间 默认0
            .showDownloadConfirmDialog(isShowDownloadConfirmDialog)//是否展示下载弹出框
            .build()
        bannerView = AdView(this, requestConfig)
        bannerView!!.setListener(object : AdViewListener {
            override fun onAdClick() {
                Log.d("CLOOOUDAD", "banner onAdClick: ")
            }

            override fun onAdFailed(arg0: String) {
                Log.d("CLOOOUDAD", "banner onAdFailed  $arg0")
                removeAdIfNecessary()
            }

            override fun onAdReady(price: Int) {
                Log.d("CLOOOUDAD", "banner onAdReady")
            }

            override fun onAdShow(cAdInfo: CAdInfo?) {
                Log.e("CLOOOUD_POLY", "ecpm: " + cAdInfo?.ecpm)
                Log.d("CLOOOUDAD", "banner onAdShow")
            }

            override fun onAdDismissed(s: String?) {
                Log.d("CLOOOUDAD", "banner onAdDismissed")
                removeAdIfNecessary()
            }
        })
        container?.removeAllViews()
        container?.addView(bannerView)
    }

    override fun onDestroy() {
        if (bannerView != null) {
            bannerView?.onDestroyAd() //回收广告
        }
        super.onDestroy()
    }

    /**
     * 移除广告
     */
    private fun removeAdIfNecessary() {
            container?.removeAllViews()
            bannerView?.onDestroyAd() //回收广告
    }
}