package com.example.ydsdkdemo

import android.annotation.SuppressLint
import android.app.Activity
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.util.Log
import android.view.View
import android.widget.Button
import android.widget.EditText
import android.widget.Toast
import com.example.ydsdkdemo.util.SharedPreferencesUtils
import com.example.ydsdkdemo.BuildConfig
import com.open.ad.polyunion.bean.CAdInfo
import com.open.ad.polyunion.listener.AdViewListener
import com.open.ad.polyunion.view.AdConfig
import com.open.ad.polyunion.view.AdRequestConfig
import com.open.ad.polyunion.view.AdView
import com.example.ydsdkdemo.R

class InterstialActivity : Activity() {

    private var InterstialAdCache: Button? = null
    private  var showInterstialAd: Button? = null
    private  var showInterstialAd2: Button? = null
    private var interstialView: AdView? = null
    private var interstialEdit: EditText? = null
    private var isShowDownloadConfirmDialog = false


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_interstial)
        isShowDownloadConfirmDialog =
            SharedPreferencesUtils.getParam(this, "isShowDownloadConfirmDialog", true) as Boolean
        InterstialAdCache = findViewById<View>(R.id.InterstialAdCache) as Button
        showInterstialAd = findViewById<View>(R.id.showInterstialAd) as Button
        showInterstialAd2 = findViewById<View>(R.id.showInterstialAd2) as Button
        interstialEdit = findViewById<View>(R.id.interstial_edit) as EditText
        InterstialAdCache!!.setOnClickListener(View.OnClickListener {
            val requestConfig: AdRequestConfig = AdRequestConfig.Builder()
                .AdType(AdConfig.AD_TYPE_INTERSTITIAL) //广告样式
                .slotId(BuildConfig.INTERSTIAL_SLOT_ID)//广告位id
              .sceneId(interstialEdit?.text.toString()) //广告场景id
                .widthDp(300) //TODO 高度不能自适应，插屏设置的高宽比例需与运营同步（300:300,200:300,300:200）
                .heightDp(300)
                //                .addSougouAdTemplate(AdTemplate.INSERT_IMG_CHARACTER_ID)
                .showDownloadConfirmDialog(true)
                .build()
            val interstialView = AdView(this@InterstialActivity, requestConfig)
            interstialView.setInterstialCache { AdSize ->
                Toast.makeText(
                    this@InterstialActivity,
                    "插屏广告缓存条数：$AdSize", Toast.LENGTH_LONG
                ).show()
            }
        })
        showInterstialAd2!!.setOnClickListener {
            requestAd()
            Handler(Looper.getMainLooper()).postDelayed({ finish() }, 200)
        }
        showInterstialAd!!.setOnClickListener {
            if (interstialView != null) {
                Log.e("CLOOOUD_", "isRewardVideoOk:" + interstialView!!.isInterstialAdOk)
                if (interstialView!!.isInterstialAdOk) {
                    interstialView!!.showInterstialAd(this@InterstialActivity)
                } else {
                    Toast.makeText(
                        this@InterstialActivity,
                        "插屏广告未就绪!",
                        Toast.LENGTH_LONG
                    ).show()
                }
            } else {
                Log.e("CLOOOUD_", "正在请求插屏广告...")
                // 开始请求广告
                showInterstialAd!!.text = "正在请求插屏广告..."
                showInterstialAd!!.isEnabled = false
                requestAd()
            }
        }
    }

    private fun requestAd() {
        Log.d("cloooudAD", "requestAd "+System.currentTimeMillis())

        val requestConfig: AdRequestConfig = AdRequestConfig.Builder()
            .AdType(AdConfig.AD_TYPE_INTERSTITIAL) //广告样式
            .slotId(BuildConfig.INTERSTIAL_SLOT_ID)//广告位id
            .sceneId(interstialEdit?.text.toString()) //广告场景id
            .widthDp(300)
            .heightDp(300)
            .showDownloadConfirmDialog(true)
            .build()
        interstialView = AdView(this, requestConfig)
        interstialView!!.setListener(object : AdViewListener {
            override fun onAdClick() {
                Log.d("CLOOOUDAD", "chapin onAdClick: ")
            }

            override fun onAdFailed(arg0: String) {
                Log.d("CLOOOUDAD", "chapin onAdFailed  $arg0")
                showInterstialAd?.text = "插屏广告"
                showInterstialAd?.isEnabled = true
                interstialView?.onDestroyAd()
                interstialView = null
                Toast.makeText(this@InterstialActivity, arg0, Toast.LENGTH_SHORT).show()
            }

            override fun onAdReady(price: Int) {
                Log.d("cloooudAD", "onAdReady "+System.currentTimeMillis())
                Log.d("CLOOOUDAD", "chapin onAdReady")
                showInterstialAd?.text = "点击展示插屏广告"
                showInterstialAd?.isEnabled = true
            }

            override fun onAdShow(cAdInfo: CAdInfo?) {
                Log.e("CLOOOUD_POLY", "ecpm: " + cAdInfo?.ecpm)
                Log.d("CLOOOUDAD", "chapin onAdShow")
            }

            override fun onAdDismissed(s: String?) {
                Log.d("CLOOOUDAD", "chapin onAdDismissed")
            }
        })
    }


    override fun onPause() {
        super.onPause()
    }

    override fun onDestroy() {
        interstialView?.onDestroyAd()
        super.onDestroy()
    }
}