package com.example.ydsdkdemo

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.CheckBox
import android.widget.CompoundButton
import android.widget.TextView
import android.widget.Toast
import com.example.ydsdkdemo.util.SharedPreferencesUtils
import com.example.ydsdkdemo.util.Util
import com.open.ad.polyunion.view.AdRequestConfig
import com.open.ad.polyunion.view.AdView
import com.open.ad.polyunion.view.NativeCachedAdUtil
import com.example.ydsdkdemo.R


class MainActivity : Activity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        initView()
    }

    private val AD_COUNT_EACH_PAGE = 3

    private fun initView() {
        val mVersion = findViewById<TextView>(R.id.version)
        mVersion.text = com.open.ad.polyunion.util.Util.getSDKVersion()
        val mShowDialogBox = findViewById<CheckBox>(R.id.mShowDialogBox)
         val isShowDownloadConfirmDialog =
            SharedPreferencesUtils.getParam(this, "isShowDownloadConfirmDialog", true) as Boolean
        mShowDialogBox.isChecked = isShowDownloadConfirmDialog
        mShowDialogBox.setOnCheckedChangeListener(CompoundButton.OnCheckedChangeListener { compoundButton, b ->
            SharedPreferencesUtils.setParam(
                this@MainActivity,
                "isShowDownloadConfirmDialog",
                b
            )
        })
    }

    fun showSplashAd(view: View?) {
        startActivity(Intent(this, SplashActivity::class.java))
    }

    fun showSplashAd2(view: View?) {
        Toast.makeText(this, "开始", Toast.LENGTH_SHORT).show()
        val intent = Intent(this, SplashActivity::class.java)
        intent.putExtra("IS_FINISH", true)
        startActivity(intent)
    }

    /**
     * 清除广告信息
     */
    fun clearAdInfo(view: View?) {
        AdView.removeInformation(applicationContext)
        Toast.makeText(this, "清除成功", Toast.LENGTH_SHORT).show()
    }


    fun showBannerAd(view: View?) {
        startActivity(Intent(this, BannerActivity::class.java))
    }

    fun showInterstialAd(view: View?) {
        startActivity(Intent(this, InterstialActivity::class.java))
    }

    fun showNativeInterstialAd(view: View?) {
    }

    fun showNativeAd(view: View?) {
        val intent = Intent(this, NativeSelectActivity::class.java)
        startActivity(intent)
    }



    fun showRewardVideoAd(view: View?) {
        startActivity(Intent(this, RewardVideoActivity::class.java))
    }

    override fun onPause() {
        super.onPause()
    }

    override fun onResume() {
        super.onResume()
    }

    override fun onDestroy() {
        super.onDestroy()
    }

}
