package com.example.ydsdkdemo

import android.app.Application
import android.content.Context
import com.example.ydsdkdemo.BuildConfig
import com.open.ad.polyunion.newedition.contract.DeniedUpDeviceInfo
import com.open.ad.polyunion.newedition.contract.InitSDKListener
import com.open.ad.polyunion.view.AdConfig
import com.open.ad.polyunion.view.AdView
import com.open.ad.polyunion.view.InitSDKConfig

//import androidx.multidex.MultiDex

/**
 * @date :2024/5/11 14:52
 * @projectName
 * @author zw
 * @description:
 */
class MyApplication : Application(){

    private val mContext: Context? = null

    override fun attachBaseContext(base: Context?) {
        super.attachBaseContext(base)
//        MultiDex.install(this);
        //聚合SDK初始化
        val initSDKConfig: InitSDKConfig = InitSDKConfig.Builder()
            .AppId(BuildConfig.APP_ID)
            .appName("广告demo")//SDK后台注册的应用名称
            .setChannel("demo")//渠道
            // 竖屏 - AdConfig.REWARD_VIDEO_SCREEN_VERTICAL
            // 横屏 - AdConfig.REWARD_VIDEO_SCREEN_x`HORIZONTAL
            .RewardVideoScreenDirection(AdConfig.REWARD_VIDEO_SCREEN_VERTICAL) // 设置激励视频播放页面的横竖屏
            .debug(true)////上线需要设置false
            .setDeniedUpDeviceInfo(object : DeniedUpDeviceInfo() {

                /**
                 * 是否允许SDK主动使用地理位置信息
                 * */
                override fun isCanUseLocation(): Boolean {
                    return super.isCanUseLocation()
                }

                /**
                 * 获取应用列表
                 * */
                override fun appList(): Boolean {
                    return super.appList()
                }

                /**
                 * 是否允许SDK主动使用手机硬件参数
                 * */
                override fun isCanUsePhoneState(): Boolean {
                    return super.isCanUsePhoneState()
                }

                /**
                 * 当isCanUsePhoneState=false时，可传入IME信息
                 * */
                override fun getDevImei(): String? {
                    return super.getDevImei()
                }

                /**
                 * 是否允许SDK主动使用ACCESS_WIFI_STATE权限
                 * */
                override fun isCanUseWifiState(): Boolean {
                    return super.isCanUseWifiState()
                }

                /**
                 * 当isCanUseWifiState=false时，可传入Mac地址信息
                 * */
                override fun getMacAddress(): String? {
                    return super.getMacAddress()
                }

                /**
                 * 是否允许SDK主动使用WRITE_EXTERNAL_STORAGE权限
                 * */
                override fun isCanUseWriteExternal(): Boolean {
                    return super.isCanUseWriteExternal()
                }

                /**
                 * 开发者可以传入OAID
                 * */
                override fun getDevOaid(): String? {
                    return super.getDevOaid()
                }

                /**
                 * 是否能获取android ID
                 * */
                override fun isCanUseAndroidId(): Boolean {
                    return super.isCanUseAndroidId()
                }


                /**
                 * 开发者可以传入android ID
                 * */
                override fun getAndroidId(): String? {
                    return super.getAndroidId()
                }

                /**
                 * 是否允许SDK在申明和授权了的情况下使用录音权限
                 * */
                override fun isCanUsePermissionRecordAudio(): Boolean {
                    return super.isCanUsePermissionRecordAudio()
                }
            })
            .setOaidProvider { "test_oaid" } //传入 OAID 获取器，建议集成 OAID SDK的应用设置
            .build()
         AdView.initSDK(this, initSDKConfig, object : InitSDKListener {
            override fun initializeSucceed() {
                //初始化成功
            }

            override fun initializeFail() {
                //初始化失败
            }
        })
//      AdView.enablePersonalizedRecommendAd(false)
        //今日头条屏幕适配
//        configUnits();
    }

    fun getContext(): Context? {
        return mContext
    }


}