package com.example.ydsdkdemo

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.EditText
import android.widget.Toast
import com.example.ydsdkdemo.ui.ShowAdDialog
import com.example.ydsdkdemo.util.Util
import com.example.ydsdkdemo.BuildConfig
import com.open.ad.polyunion.view.AdRequestConfig
import com.open.ad.polyunion.view.NativeCachedAdUtil
import com.example.ydsdkdemo.R

class NativeSelectActivity : Activity() {


    private var nativeEdit : EditText? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_native_select)
        nativeEdit = findViewById<View>(R.id.native_edit) as EditText
    }

    /**
     * 使用当前广告位
     */
    fun requestMachining4(view: View?) {
        ShowAdDialog(this@NativeSelectActivity)
    }

    /**
     * 使用当前广告位
     */
    fun accessSceneAd1(view: View?) {
//        AdDialog adDialog = new AdDialog(NativeSelectActivity.this);
//        adDialog.show();
        val intent = Intent(
            this@NativeSelectActivity,
            NativeActivity::class.java
        )
        intent.putExtra("IS_CACHE", "true")
        intent.putExtra("SCENE_ID", nativeEdit?.text.toString())
        intent.putExtra("SLOT_ID", BuildConfig.NATIVE_FEED_SLOT_ID)
        startActivity(intent)
    }

    fun accessSceneAd2(view: View?) {
        val intent = Intent(
            this@NativeSelectActivity,
            NativeActivity::class.java
        )
        intent.putExtra("IS_CACHE", "true")
        intent.putExtra("SCENE_ID", nativeEdit?.text.toString())
        intent.putExtra("SLOT_ID", BuildConfig.NATIVE_FEED_SLOT_ID)
        startActivity(intent)
    }

    fun accessSceneAd3(view: View?) {
        val intent = Intent(
            this@NativeSelectActivity,
            NativeActivity::class.java
        )
        intent.putExtra("IS_CACHE", "true")
        intent.putExtra("SCENE_ID", nativeEdit?.text.toString())
        intent.putExtra("SLOT_ID", BuildConfig.NATIVE_FEED_SLOT_ID)
        startActivity(intent)
    }

    fun requestMachining1(view: View?) {
        Thread {
            val adRequestConfig1: AdRequestConfig =
                createAdRequestConfig(BuildConfig.NATIVE_FEED_SLOT_ID)
            val adRequestConfig2: AdRequestConfig =
                createAdRequestConfig(BuildConfig.NATIVE_FEED_SLOT_ID)
            val adRequestConfig3: AdRequestConfig =
                createAdRequestConfig(BuildConfig.NATIVE_FEED_SLOT_ID)
            val adRequestConfigs: ArrayList<AdRequestConfig> =
                ArrayList<AdRequestConfig>()
            adRequestConfigs.add(adRequestConfig1)
            adRequestConfigs.add(adRequestConfig2)
            adRequestConfigs.add(adRequestConfig3)
            NativeCachedAdUtil.getInstance().cacheAd(this@NativeSelectActivity, adRequestConfigs)
        }.start()
        Toast.makeText(this@NativeSelectActivity, "缓存场景3缓存成功", Toast.LENGTH_LONG).show()
    }

    fun requestMachining3(view: View?) {
        val intent = Intent(
            this@NativeSelectActivity,
            NativeActivity::class.java
        )
        intent.putExtra("IS_CACHE", "true")
        intent.putExtra("IS_FINISH", true)
        intent.putExtra("SCENE_ID", nativeEdit?.text.toString())
        intent.putExtra("SLOT_ID", BuildConfig.NATIVE_FEED_SLOT_ID)
        startActivity(intent)
    }

    fun requestMachining2(view: View?) {
        val adRequestConfig1: AdRequestConfig =
            createAdRequestConfig("")
        val adRequestConfigs: ArrayList<AdRequestConfig> = ArrayList<AdRequestConfig>()
        adRequestConfigs.add(adRequestConfig1)
        NativeCachedAdUtil.getInstance().cacheAd(applicationContext, adRequestConfigs)
        val intent = Intent(
            this@NativeSelectActivity,
            NativeActivity::class.java
        )
        intent.putExtra("IS_CACHE", "true")
        intent.putExtra("SCENE_ID", nativeEdit?.text.toString())
        intent.putExtra("SLOT_ID", BuildConfig.NATIVE_FEED_SLOT_ID)
        startActivity(intent)
    }


    /**
     * 缓存
     */
    fun cacheSceneAd1(view: View?) {
        Thread {
            val adRequestConfig: AdRequestConfig =
                createAdRequestConfig(BuildConfig.NATIVE_FEED_SLOT_ID)
            NativeCachedAdUtil.getInstance().cacheAd(applicationContext, adRequestConfig)
        }.start()
        Toast.makeText(this@NativeSelectActivity, "缓存场景1缓存成功", Toast.LENGTH_LONG).show()
    }

    fun cacheSceneAd2(view: View?) {
        val adRequestConfig: AdRequestConfig =
            createAdRequestConfig(BuildConfig.NATIVE_FEED_SLOT_ID)
        NativeCachedAdUtil.getInstance().cacheAd(applicationContext, adRequestConfig)
        Toast.makeText(this@NativeSelectActivity, "缓存场景2缓存成功", Toast.LENGTH_LONG).show()
    }

    fun cacheSceneAd3(view: View?) {
        val adRequestConfig3: AdRequestConfig =
            createAdRequestConfig(BuildConfig.NATIVE_FEED_SLOT_ID)
        NativeCachedAdUtil.getInstance().cacheAd(applicationContext, adRequestConfig3)
        Toast.makeText(this@NativeSelectActivity, "缓存场景3缓存成功", Toast.LENGTH_LONG).show()
    }


    private fun createAdRequestConfig(slotId: String): AdRequestConfig {
//        boolean isShowDownloadConfirmDialog = (boolean) SharedPreferencesUtils.getParam(this, "isShowDownloadConfirmDialog", true);
        val screenSizeDP: IntArray = Util.getScreenSizeInDP(applicationContext)
        return AdRequestConfig.Builder()
            .slotId(slotId)//广告位id
            .sceneId(nativeEdit?.text.toString()) //广告场景id
            .widthDp(screenSizeDP[0]) //请求图片宽度dp值
            .heightDp(0) //请求图片高度dp值
            .requestCount(1) //信息流广告请求条数
            .isVideoVoiceOn(false)
            /**
             * 设置视频自动播放场景：
             * ALWAYS - 所有网络环境均自动播放
             * WIFI - WIFI网络环境自动播放
             * NEVER - 所有网络环境均不会自动播放
             */
            .videoAutoPlayPolicy(AdRequestConfig.VideoAutoPlayPolicy.ALWAYS) //                .addSougouAdTemplate(AdTemplate.BIG_IMG_TPL_ID)
            //                .addSougouAdTemplate(AdTemplate.DOWNLOAD_BIG_TPL_ID)
            .showDownloadConfirmDialog(true)
            .isAdNeedRemoveDuplicates(true)
            .build()
    }
}