package com.example.ydsdkdemo

import android.app.Activity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Button
import android.widget.EditText
import android.widget.Toast
import com.example.ydsdkdemo.util.SharedPreferencesUtils
import com.example.ydsdkdemo.BuildConfig
import com.open.ad.polyunion.bean.CAdInfo
import com.open.ad.polyunion.listener.RewardVideoListener
import com.open.ad.polyunion.view.AdConfig
import com.open.ad.polyunion.view.AdRequestConfig
import com.open.ad.polyunion.view.AdView
import com.example.ydsdkdemo.R

class RewardVideoActivity : Activity() {

    private var mRewardVideoView: AdView? = null
    private var mShowVideoBtn: Button? = null
    private var isShowDownloadConfirmDialog = false
    private var rewardEdit: EditText? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_reward_video)

        isShowDownloadConfirmDialog =
            SharedPreferencesUtils.getParam(this, "isShowDownloadConfirmDialog", true) as Boolean

        mShowVideoBtn = findViewById(R.id.showVideo)
        rewardEdit = findViewById(R.id.reward_edit)
        mShowVideoBtn!!.setOnClickListener { _: View? ->
            if (mRewardVideoView != null && mRewardVideoView!!.isRewardVideoOk) {
                mRewardVideoView!!.showRewardVideoAd(this)
            } else {
                Toast.makeText(
                    this@RewardVideoActivity,
                    "获取视频为空",
                    Toast.LENGTH_LONG
                ).show()
            }
        }
    }

    private fun showPloyVideo(isCache: Boolean, slotId: String) {
        if (mRewardVideoView != null) {
            mRewardVideoView = null
        }
        val requestConfig: AdRequestConfig = AdRequestConfig.Builder()
            .AdType(AdConfig.AD_TYPE_REWARDVIDEO)
            .slotId(slotId)//广告位id
            .sceneId(rewardEdit?.text.toString()) //广告场景id
            .showDownloadConfirmDialog(isShowDownloadConfirmDialog)
            .build()
        mRewardVideoView = AdView(this, requestConfig)
        mRewardVideoView!!.setRewardVideoListener(object : RewardVideoListener {
            override fun onAdReady(price: Int) { //视频广告准备就绪，回调此方法后可以调用播放接口
                Toast.makeText(this@RewardVideoActivity, "激励视频广告就绪", Toast.LENGTH_SHORT)
                    .show()

                // 视频准备就绪，才允许播放
                mShowVideoBtn!!.text = "点击播放视频"
                mShowVideoBtn!!.isEnabled = true
            }

            override fun onVideoCached() {
                Toast.makeText(this@RewardVideoActivity, "激励视频广告缓冲成功", Toast.LENGTH_SHORT)
                    .show()
            }

            override fun onAdShow(cAdInfo: CAdInfo?) { //广告展示
                //                Toast.makeText(RewardVideoActivity.this, "激励视频广告展示", Toast.LENGTH_SHORT).show();
            }

            override fun onAdClick(s: String?) { //广告被点击
                Toast.makeText(this@RewardVideoActivity, "激励视频广告点击", Toast.LENGTH_SHORT)
                    .show()
            }

            override fun onAdFailed(s: String) { //广告返回失败或展示失败（灭屏状态调用播放回调此方法）
                Toast.makeText(
                    this@RewardVideoActivity,
                    "激励视频广告加载失败: $s", Toast.LENGTH_SHORT
                ).show()
               onAdLoadFailed();
            }

            override fun onVideoComplete() { //播放完成
                Toast.makeText(this@RewardVideoActivity, "激励视频广告播放完成", Toast.LENGTH_SHORT)
                    .show()
            }

            override fun onAdReward() { //激励视频触发激励
                Toast.makeText(this@RewardVideoActivity, "激励视频广告触发奖励", Toast.LENGTH_SHORT)
                    .show()
            }

            override fun onAdClose() { //视频广告界面关闭
                Toast.makeText(this@RewardVideoActivity, "激励视频广告关闭", Toast.LENGTH_SHORT)
                    .show()
                // 退出，再次进入重新加载激励视频
                finish()
            }
        })
    }

    /**
     * 使用当前广告位
     */
    fun accessVideoSceneAd1(view: View?) {
        showPloyVideo(true, BuildConfig.REWARD_VIDEO_SLOT_ID)
    }

    fun accessVideoSceneAd2(view: View?) {
        showPloyVideo(true, BuildConfig.REWARD_VIDEO_SLOT_ID)
    }

    fun accessVideoSceneAd3(view: View?) {
        showPloyVideo(true, BuildConfig.REWARD_VIDEO_SLOT_ID)
    }

    /**
     * 缓存
     */
    fun cacheVideoSceneAd1(view: View?) {
        createAdRequestConfig(BuildConfig.REWARD_VIDEO_SLOT_ID)
    }

    fun cacheVideoSceneAd2(view: View?) {
        createAdRequestConfig(BuildConfig.REWARD_VIDEO_SLOT_ID)
    }

    fun cacheVideoSceneAd3(view: View?) {
        createAdRequestConfig(BuildConfig.REWARD_VIDEO_SLOT_ID)
    }

    private fun createAdRequestConfig(slotId: String) {
        val requestConfig: AdRequestConfig = AdRequestConfig.Builder()
            .AdType(AdConfig.AD_TYPE_REWARDVIDEO)
            .slotId(slotId)//广告位id
//            .sceneId("2323524") //广告场景id
            .showDownloadConfirmDialog(isShowDownloadConfirmDialog)
            .build()
        AdView(this, requestConfig).setRewardVideoCache { ADSize: Int ->
            Toast.makeText(
                this@RewardVideoActivity,
                "激励视频广告缓存成功,缓存广告条数$ADSize",
                Toast.LENGTH_LONG
            ).show()
        }
    }

    /**
     * 激励视频加载失败界面处理
     */
    private fun onAdLoadFailed() {
        // 视频准备就绪，才允许播放
        mShowVideoBtn!!.text = "点击加载激励视频广告"
        mShowVideoBtn!!.isEnabled = true
        mRewardVideoView?.onDestroyAd()
        mRewardVideoView = null
    }

    override fun onDestroy() {
        super.onDestroy()
        mRewardVideoView?.onDestroyAd()
    }

}